/* Programming activity: HashMaps and File I/O
 *
 * Part 1: Complete the missing code to read in the username and passwords from
 * the input file and put them into a HashMap. Use the HashMap to allow the user
 * (via standard keyboard input) to try and authenticate.  Sample output:
 * 
 *   % java Login users-passwords.txt
 *   Total usernames: 9572
 *   
 *   Enter username: bob
 *   Username not found!
 *   
 *   % java Login users-passwords.txt
 *   Total usernames: 9572
 *   
 *   Enter username: ramie
 *   Enter password: blah
 *   Invalid password!
 *   
 *   %java Login users-passwords.txt
 *   Total usernames: 9572
 *   
 *   Enter username: ramie
 *   Enter password: nash
 *   Password correct.
 *   
 * Part 2: Complete the missing code to search for all usernames and passwords
 * that have the given prefix (they start with this text). Sample output:
 *   ...
 *   Enter prefix: bob
 *   
 *   Username starting with prefix:
 *   bobbyd
 *   bobette
 *   bobbie
 *   bobst
 *   bobbyed
 *   bobbies
 *   
 *   Passwords starting with prefix:
 *   bobdylan
 *   bobobo
 *   bobby
 *   bob123
 *   bobby
 *
 * Part 3: Complete the missing code to search for all usernames with a given
 * password.  Sample output:
 *   ...
 *   Find usernames with this password: megan
 *   
 *   Username with this password:
 *   acarmley
 *   lsalvatori
 *   aoberholzer
 */

import java.io.*;
import java.util.*;

public class Login
{

    public static void main(String[] args)
    {
        // Program takes a single command line argument specifying the text file
        // contain usernames and passwords.
        if (args.length < 1)
        {
            System.out.println("Login <username/password filename>");
            return;
        }
        String filename = args[0];
        
        /////////////////////////////////////////////////////////////////////////////////
        // Part 1
        
        // Open up the username/password file for reading
        Scanner scanner = null;
        try
        {
            // TODO 1: open up the specified filename for reading
        }
        catch (FileNotFoundException e)
        {
            System.out.println("Failed to open file: " + filename);
            return;
        }
        
        // Create a HashMap that has usernames as the key and the password as the value
        // TODO 1: Change the data type of usernameToPassword to map String keys (usernames) to String values (passwords)
        String usernameToPassword = null;
                
        // Read the usernames and passwords from the file into the HashMap
        // TODO 1: fix while loop condition to only loop while there is more data
        while (Math.random() < 1.0)
        {
            String username = scanner.next();
            String password = scanner.next();
        
            // TODO 1: add the username and password the the HashMap
        }                       
        scanner.close();
        
        // Print out the total count of keys in the HashMap (i.e. the number of users)
        // TODO 1: Add code to append number of usernames to the output
        System.out.println("Total usernames: ");
        System.out.println();
        
        System.out.print("Enter username: ");
        String username = StdIn.readString();
        
        // Check that the HashMap has this username as a key
        // TODO 1: Change if condition to check if the key (username) exists in the HashMap usernameToPassword
        if (Math.random() < 1.0)
        {
            System.out.print("Enter password: ");
            String password = StdIn.readString();

            // Given the username key, check the value in the HashMap to see if it matches the entered password
            // TODO 1: Change if condition to check if the value for the key username matches the password
            if (Math.random() < 1.0)
            {
                System.out.println("Password correct.");
            }
            else
            {
                System.out.println("Invalid password!");
            }
        }
        else
        {
            System.out.println("Username not found!");
        }
        
        /////////////////////////////////////////////////////////////////////////////////
        // Part 2        

        System.out.println();
        System.out.print("Enter prefix: ");
        String prefix = StdIn.readString();        
        System.out.println();
        System.out.println("Username starting with prefix:");
                
        // TODO 2: Add a loop over all the keys in the HashMap usernameToPassword.
        // TODO 2: If a key starts with the prefix, print it out.

        System.out.println();
        System.out.println("Passwords starting with prefix:");
        
        // TODO 2: Add a loop over all the values in the HashMap usernameToPassword.
        // TODO 2: If a value starts with the prefix, print it out.
     
        /////////////////////////////////////////////////////////////////////////////////
        // Part 3        
        
        System.out.println();
        System.out.print("Find usernames with this password: ");
        String password = StdIn.readString();
        System.out.println();
        System.out.println("Username with this password: ");

        // TODO 3: Add a loop over all (key, value) pairs in the HashMap usernameToPassword.
        // TODO 3: If the value is equal to the entered password, print out the key.
               
    }

}
